// Let's concatenative-synthesis!
ConcatSynth concat => dac;

// 1. Optionally set number of MFCCs to be used in all analysis.
//    13 is the default. 48 is the maximum. 
//    We ignore the 0th MFCC, so you are actually using 
//    one fewer than this.
40 => concat.mfccCount;

// 2. Add source sound files.
concat.addSource( me.dir() + "basketball" + ".wav");
concat.addSource( me.dir() + "coffee-bubble" + ".wav");
concat.addSource( me.dir() + "coffee-grind" + ".wav");
concat.addSource( me.dir() + "filing-cabinet" + ".wav");
concat.addSource( me.dir() + "fire-hydrant" + ".wav");
concat.addSource( me.dir() + "garbage" + ".wav");
concat.addSource( me.dir() + "lawn-mower" + ".wav");
concat.addSource( me.dir() + "mac-startup" + ".wav");
concat.addSource( me.dir() + "macpro-startup-fuzzy" + ".wav");
concat.addSource( me.dir() + "pot-1" + ".wav");
concat.addSource( me.dir() + "pot-2" + ".wav");
concat.addSource( me.dir() + "rice-cooker" + ".wav");
concat.addSource( me.dir() + "shopping-cart" + ".wav");
concat.addSource( me.dir() + "soda-can" + ".wav");
concat.addSource( me.dir() + "vacuum-cleaner" + ".wav");
concat.addSource( me.dir() + "washing-machine" + ".wav");
concat.addSource( me.dir() + "wood-creak" + ".wav");
concat.finalizeSources();
concat.enableFuzzyMatching( 4 );

// 3. Optionally set maxVoices. You won't be able to have 
//    more than this many grains active at once.
//    200 is the maximum.
40 => concat.maxVoices;

// 4. We match against the input to the concatenator. 
//    Here let's use the mic, but delayed.
// adc => Delay d => concat;
//2::second => d.max => d.delay;

// Just kidding let's just use the mic.
adc => concat;

global int matchedBuffer;
global float inputLoudness;

// 5. Trigger grains!
while( true )
{
    // triggerGrain( grain length, ramp up time, ramp down time )
    // concat.triggerFuzzyGrain( 1000::ms, 500::ms, 500::ms );
    concat.triggerFuzzyGrain( 1000::ms, 500::ms, 500::ms );    
    chout <= ""I matched buffer ""    
    <= concat.matchedBuffer() 
    <= "" at sample "" 
    <= concat.matchedSample() 
    <= IO.newline();
        
    concat.matchedBuffer() => matchedBuffer;    
    concat.inputLoudness() => inputLoudness;
    // 100::ms => now;    
    50::ms => now;
}        
